#totem fix
execute as @a[tag=!totem_effect_fix] run function roguecraft:misc/effect_fix/totem/get_effects_from_player with entity @s

#mana
execute as @a run scoreboard players operation @s mana += @s mana_regen
execute as @a if score @s class matches 1 run scoreboard players add @s mana 2
execute as @a if score @s final_adrenaline_timer matches 0.. run scoreboard players add @s mana 2
execute as @a[nbt={Dimension:"minecraft:overworld"}] if data storage roguecraft:master {blue_moon:1b} run scoreboard players add @s mana 3
execute as @a if score @s mana > @s mid_run_max_mana run scoreboard players operation @s mana = @s mid_run_max_mana
execute as @a run function roguecraft:misc/execute_with_player_id {function:"roguecraft:ability/set_mana_bar"}

#difficulty
execute if entity @a[tag=!hub,tag=!garden] if data storage roguecraft:master {bedrock_platform_left:1} unless entity @a[tag=victory] run scoreboard players add #roguecraft_master difficulty 1
execute store result bossbar minecraft:difficulty value run scoreboard players get #roguecraft_master difficulty
execute if score #roguecraft_master difficulty >= #roguecraft_master difficulty_val_max run function roguecraft:difficulty/increase_difficulty

#clear weather
execute if entity @a[tag=hub] in minecraft:overworld run weather clear
execute if entity @a[tag=garden] in minecraft:overworld run weather clear
execute if entity @a[tag=victory] in minecraft:overworld run weather clear

#game loop
execute if data storage roguecraft:master {run_active:1} run execute as @a[tag=hub,tag=!garden,tag=ready] run function roguecraft:game_loop/run_start_singular with storage roguecraft:master Region
execute if data storage roguecraft:master {run_active:0} run execute as @a[tag=!hub,tag=!garden] unless data entity @s {Health:0.0f} run function roguecraft:game_loop/run_end_singular {message:"{translate:\"roguecraft.title.defeat\",bold:true,color:\"dark_red\"}",sound:"minecraft:entity.wither.spawn master @s[tag=!garden,tag=!hub] 0.00 64 0.00 0.2 0.75"}
execute if data storage roguecraft:master {run_active:1} as @a[tag=!hub,tag=!garden] if score @s run_number < #roguecraft_master run_number run function roguecraft:game_loop/run_end_singular {message:"{translate:\"roguecraft.title.defeat\",bold:true,color:\"dark_red\"}",sound:"minecraft:entity.wither.spawn master @s[tag=!garden,tag=!hub] 0.00 64 0.00 0.2 0.75"}

#healer aura
execute as @a at @s if entity @a[distance=..10,scores={class=2},gamemode=!spectator] run effect give @s[tag=!hub] minecraft:regeneration 2 0 true

#compass
execute as @a[scores={compass=1..}] at @s run function roguecraft:compass/check_hands

#wildfire
execute as @a[gamemode=!spectator,nbt={Dimension:"minecraft:the_nether"}] at @s run function roguecraft:wildfire/check_spawner_exists

#hub
execute as @a[tag=!tutorial_done,tag=init_player] in roguecraft:infinite_garden positioned 0 63 0 if entity @s[distance=..15] run function roguecraft:infinite_garden/hub/finish_tutorial

#bedrock platform check
execute if data storage roguecraft:master {bedrock_platform_left:0} as @a[tag=!garden,tag=!hub] at @s unless block ~ ~-1 ~ minecraft:barrier as @e[type=minecraft:interaction,tag=bedrock_blocker] at @s run function roguecraft:misc/remove_bedrock_blocker
execute if data storage roguecraft:master {bedrock_platform_left:0} as @a[tag=!garden,tag=!hub] at @s unless block ~ ~-1 ~ minecraft:barrier run data modify storage roguecraft:master bedrock_platform_left set value 1

#speedruns
execute if entity @a if score #roguecraft_master run_number matches 1.. run function roguecraft:speedrun/update_speedrun_timer

#ender dragon
execute at @e[type=minecraft:area_effect_cloud,tag=auto_aim] run execute as @e[type=!minecraft:item,distance=..3] run damage @s 4 minecraft:magic by @e[type=minecraft:ender_dragon,limit=1]

#scroll enemies
execute if data storage roguecraft:master {run_active:1} as @e[type=#roguecraft:difficulty/difficulty_scroll] at @s run function roguecraft:difficulty/scroll/second

#triggers
execute as @a if entity @s[tag=!hub,tag=!garden] run scoreboard players reset @s new_world_timer
execute as @a if entity @s[tag=!hub,tag=!garden] run scoreboard players reset @s single_run_timer
execute as @a unless entity @s[tag=!hub,tag=!garden] run scoreboard players enable @s new_world_timer
execute as @a unless entity @s[tag=!hub,tag=!garden] run scoreboard players enable @s single_run_timer

#giant forceload
execute as @e[type=minecraft:marker,tag=giant] at @s run function roguecraft:giant/second with entity @s data

#info messages
execute as @a[tag=hub,scores={enderchest_used=1..},tag=!info_loadout] unless score @s toggle_info_messages matches 2 run function roguecraft:info_messages/loadout
execute as @a[scores={skillpoints=1..},tag=!info_skillpoint] unless score @s toggle_info_messages matches 2 run function roguecraft:info_messages/skillpoint

schedule function roguecraft:second 1s