#start platform effect
execute at @r[tag=!garden,tag=!hub] as @n[tag=bedrock_blocker,type=minecraft:interaction,distance=..5] at @s run function roguecraft:particles/start_platform/main

#advancements
execute as @a[advancements={roguecraft:roguecraft/skillpoint_100=false},scores={skillpoints=100..}] run advancement grant @s only roguecraft:roguecraft/skillpoint_100
execute as @a[advancements={roguecraft:challenges/skillpoint_500=false},scores={skillpoints=500..}] run advancement grant @s only roguecraft:challenges/skillpoint_500
scoreboard players remove @a adrenaline_advancement_timer 1
#execute as @a[advancements={roguecraft:roguecraft/instant_regret=false},scores={deaths=1..,adrenaline_advancement_timer=1..}] run advancement grant @s only roguecraft:roguecraft/instant_regret

#equipment upgrades
#execute as @a[tag=update_inventory] run function roguecraft:misc/update_inventory
execute as @a[tag=equipment_upgrade] run function roguecraft:equipment_upgrades/check_data

#wildfire
execute if entity @e[type=minecraft:marker,tag=wildfire] run function roguecraft:tick/wildfire
execute as @e[type=minecraft:marker,tag=wildfire_particle_marker,tag=marked] at @s run function roguecraft:wildfire/particle/process_1
execute as @e[type=minecraft:marker,tag=wildfire_particle_marker,tag=!marked] at @s run function roguecraft:wildfire/particle/init
scoreboard players remove @e[type=minecraft:marker,tag=wildfire_particle_marker] marker_distance 1
execute as @e[type=minecraft:marker,tag=wildfire_particle_marker,scores={marker_distance=..0}] at @s run function roguecraft:wildfire/particle/destroy
execute at @e[type=minecraft:marker,tag=wildfire_particle] run particle minecraft:flame ~ ~ ~ 0.25 0.25 0.25 0 5
execute at @e[type=minecraft:marker,tag=wildfire_particle,sort=random,limit=1] run playsound minecraft:block.fire.ambient master @a ~ ~ ~ 0.15 2

#restart run
execute as @a[tag=!hub,scores={restart_run=1..},gamemode=!spectator,tag=!garden] at @s run function roguecraft:trigger_commands/restart_run
execute as @a[scores={restart_run=1..},gamemode=spectator] run tellraw @s {translate:"roguecraft.chat_messages.restart_dead",italic:true,color:"red"}
execute as @a[scores={restart_run=1..},gamemode=spectator] at @s run playsound minecraft:block.note_block.didgeridoo master @s ~ ~ ~ 1 0.5
scoreboard players enable @a restart_run
scoreboard players set @a restart_run 0

#death
execute as @a[scores={deaths=1..}] run function roguecraft:misc/run_death

#award skill gems
execute as @a[tag=!hub,gamemode=!spectator,tag=!garden] store result score @s level_current run xp query @s levels
execute as @a[tag=!hub,gamemode=!spectator,tag=!garden] run execute if score @s level_current > @s level_max run function roguecraft:skillpoints/skill_gem

#give skill points for items
execute as @a store result score @s temp run clear @s minecraft:structure_void 0
execute as @a unless score @s temp matches 0 run function roguecraft:skillpoints/get_skillpoint_types

#get nether coords
execute as @a[gamemode=!spectator,gamemode=!adventure,advancements={story/enter_the_nether=true},scores={enter_nether=0}] run function roguecraft:skillpoints/enter_nether

#custom ender dragon
execute if data storage roguecraft:master {end:0} if entity @a[nbt={Dimension:"minecraft:the_end"}] in minecraft:the_end if loaded 0 0 0 run forceload add -100 -100 100 100
execute if data storage roguecraft:master {end:0} if entity @a[nbt={Dimension:"minecraft:the_end"}] in minecraft:the_end if loaded 0 0 0 run tag @e[type=minecraft:ender_dragon] remove cdragon
execute if data storage roguecraft:master {end:0} if entity @a[nbt={Dimension:"minecraft:the_end"}] in minecraft:the_end if loaded 0 0 0 run schedule function custom_ender_dragon:activate_end 5t append
execute if data storage roguecraft:master {end:1} run function custom_ender_dragon:tick
execute as @a[nbt={Dimension:"minecraft:the_end"},tag=!end] unless entity @a[tag=victory] run function custom_ender_dragon:enter_end

#stronghold location
execute as @a[scores={stronghold_location=1..}] run function roguecraft:trigger_commands/tell_stronghold with storage roguecraft:master Region

#return_to_hub
execute as @a[scores={return_to_hub=1..}] run function roguecraft:trigger_commands/return_to_hub

#sleep prevention
execute as @a[nbt={SleepTimer:99s},tag=!garden,tag=!hub] run schedule function roguecraft:misc/prevent_sleep 5t

#compass route changing
scoreboard players remove @a[scores={compass_delay=1..}] compass_delay 1

#spectator particles for alive players
execute at @a[gamemode=spectator] run particle minecraft:soul_fire_flame ~ ~1 ~ 0.25 0.25 0.25 0 1 normal @a[gamemode=!spectator]
execute at @a[gamemode=spectator] run particle minecraft:sculk_soul ~ ~1 ~ 0.125 0.125 0.125 0 1 normal @a[gamemode=!spectator]

#call other tick functions
execute if entity @a[tag=victory] run function roguecraft:tick/final
execute if data storage roguecraft:master {raid:{active:1b}} as @e[type=minecraft:zombie,tag=giant] at @s run function roguecraft:tick/giant
execute if data storage roguecraft:master {raid:{active:1b}} as @e[type=minecraft:marker,tag=village_center] at @s run function roguecraft:tick/raid/main
execute if data storage roguecraft:master {stronghold_spawned:1b} in minecraft:overworld positioned ~-128 ~ ~-128 if entity @a[y=-60,dy=24,dx=256,dz=256] run function roguecraft:tick/stronghold